ALTER TABLE ROOM DROP COLUMN ROOM_PURPOSE;

CREATE TABLE IF NOT EXISTS ROOM_PURPOSE
(
    ID                  SERIAL PRIMARY KEY,
    PURPOSE             VARCHAR(40) NOT NULL
);


CREATE TABLE IF NOT EXISTS LECTURE_TYPE_ROOM_PURPOSE
(
    LECTURE_TYPE_ID     INTEGER NOT NULL,
    ROOM_PURPOSE_ID     INTEGER NOT NULL,
    PRIMARY KEY (LECTURE_TYPE_ID, ROOM_PURPOSE_ID)
);

CREATE TABLE IF NOT EXISTS ROOM_ROOM_PURPOSE
(
    ROOM_ID     INTEGER NOT NULL,
    ROOM_PURPOSE_ID     INTEGER NOT NULL,
    PRIMARY KEY (ROOM_ID, ROOM_PURPOSE_ID)
);


ALTER TABLE LECTURE
    DROP COLUMN IF EXISTS GROUP_ID;

ALTER TABLE LECTURE_TYPE_ROOM_PURPOSE
    ADD CONSTRAINT FK_LECTURE_TYPE_ID_LECTURE_TYPE FOREIGN KEY (LECTURE_TYPE_ID)
        REFERENCES LECTURE_TYPE(ID);

ALTER TABLE LECTURE_TYPE_ROOM_PURPOSE
    ADD CONSTRAINT FK_ROOM_PURPOSE_ROOM_PURPOSE_ID FOREIGN KEY (ROOM_PURPOSE_ID)
        REFERENCES ROOM_PURPOSE (ID);

ALTER TABLE ROOM_ROOM_PURPOSE
    ADD CONSTRAINT FK_ROOM_ROOM_PURPOSE_ID FOREIGN KEY (ROOM_PURPOSE_ID)
        REFERENCES ROOM_PURPOSE(ID);

ALTER TABLE ROOM_ROOM_PURPOSE
    ADD CONSTRAINT FK_ROOM_ROOM_ID FOREIGN KEY (ROOM_ID)
        REFERENCES ROOM (ID);